<template>
  <div>

    <b-card
      no-body
      class="mb-0"
    >
      
      <b-form
        class="p-5"
        @submit.stop.prevent
      >
      <div class = "title">
        <h4>Editar detalles de actividad</h4>
      </div>
      <br>
        <b-alert variant="warning" :show="showAlert">Hay un campo vacio</b-alert>
        <b-alert variant="warning" :show="showAlertRequest">{{errorMessageRequest}}</b-alert>
          <b-form-group
            label="Nombre de la actividad"
            label-for="name"
            class="w-50"
          >
            <b-form-input
              id="name"
              v-model="formData.name"
              autofocus
              maxlength="50"
              trim
              :state="validationName"
              placeholder="Nombre de la actividad..."
            />
            <b-form-invalid-feedback :state="validationName">
                Este campo es obligatorio
            </b-form-invalid-feedback>
        
          </b-form-group>
          
          <b-form-group
              label="Descripción"
              label-for="description"
              class="w-50"
            >
              <b-form-input
                id="description"
                v-model="formData.description"
                maxlength="150"
                autofocus
                trim
                :state="validationDescription"
                placeholder="Descripción de la actividad"
              />
              <b-form-invalid-feedback :state="validationDescription">
                  Este campo debe tener tener al menos 4 caracteres
              </b-form-invalid-feedback>

                  
          </b-form-group>
          <b-form-group
              label="Seleccionar status de la actividad:"
              label-for="select-status"
              class="w-50"
              :state="checkStatus"
              v-if="(hasPermission('edit_project_activities') || (activitieData.project && userId === activitieData.project.manager_id)) && statusId > 1"
            >
              <b-form-select name="select-activitie-manager" v-model="formData.status_id" id="select-status">
                <b-form-select-option v-for="(state,idx) in status" :key="idx" :value="state.id">{{state.name}}</b-form-select-option>
                            
                
              </b-form-select>
              <b-form-invalid-feedback :state="checkStatus">
                    ¡Si deja el status de la actividad como nuevo, se perderán los progresos de la actividad!
              </b-form-invalid-feedback>
 
          </b-form-group>

          <b-form-group
            label="Porcentaje de avance de la actividad"
            label-for="percentage"
            class="w-50"
            v-if="formData.status_id > 1 "
          >
              
            <b-form-spinbutton
              id="percentage"
              v-model="formData.percentage_advance"
              max="100"
              :min="min_percentage"
            />
          </b-form-group>

          <b-form-group
            label="Duración estimada de la actividad (horas)"
            label-for="estimated_duration"
            v-if="hasPermission('edit_project_activities') && (formData.status_id > 1 )"
            class="w-50"
          >
              
            <b-form-input
                id="estimated_duration"
                v-model="formData.estimated_time"
                type="number"
                onKeyUp=" if (this.value.length > 5) this.value = this.value.slice(0, 5)"
                trim
                :state="validationEstimatedTime"
                placeholder="Duración estimada (horas)"
              />
              <b-form-invalid-feedback :state="validationEstimatedTime">
                  La duración debe ser un número mayor o igual a cero
              </b-form-invalid-feedback>
          </b-form-group>
        
          <b-form-group
            label="Duración real de la actividad (horas)"
            label-for="real_duration"
            v-if="hasPermission('edit_project_activities') && (formData.status_id > 1 )"
            class="w-50"
          >
              
            <b-form-input
                id="real_duration"
                v-model="formData.real_time"
                type="number"
                onKeyUp=" if (this.value.length > 5) this.value = this.value.slice(0, 5)"
                trim
                :state="validationRealTime"
                placeholder="Duración real (horas)"
              />
              <b-form-invalid-feedback :state="validationRealTime">
                  La duración debe ser un número mayor o igual a cero
              </b-form-invalid-feedback>
          </b-form-group>

          <b-form-group
              label="Seleccionar encargado de la actividad:"
              v-if="hasPermission('edit_project_activities') || (activitieData.project && userId === activitieData.project.manager_id)"
              label-for="select-activitie-manager"
              class="w-50"
            >
              <b-form-select name="select-activitie-manager" v-model="formData.manager_id" class="mb-3" id="select-activitie-manager">
                <b-form-select-option :value="null" disabled>-- Por favor ecoge un encargado --</b-form-select-option>
                <b-form-select-option v-for="(member,idx) in projectMembers" :key="idx" :value="member.id">{{member.name}} {{member.last_name}}</b-form-select-option>
              </b-form-select>
          
                  
          </b-form-group>


          <div class="d-flex mt-2">
            <b-button
              v-if="hasPermission('edit_project_activities')"
              variant="primary"
              class="mr-2"
              type="submit"
              :disabled="lockedSubmitByDescription || lockedSubmitByName || lockedSubmitByRealTime || lockedSubmitByEstimatedTime"
              @click="handleSubmit()"
            >
              Guardar
            </b-button>
            <b-button
              v-else
              variant="primary"
              class="mr-2"
              type="submit"
              :disabled="lockedSubmitByDescription || lockedSubmitByName"
              @click="handleSubmit()"
            >
              Guardar
            </b-button>
            
            <b-button
  
              type="button"
              @click="$router.back()"
              variant="outline-secondary"
           
            >
              Cancelar
            </b-button>
          </div>
      </b-form>
    </b-card>
    


  </div>
</template>

<script>
import {
  BSidebar, BForm, BFormGroup, BFormSpinbutton,BFormInput, BFormInvalidFeedback, BButton,BTab, BTabs, 
  BCard, BAlert, BLink,BFormSelect,BFormSelectOption
} from 'bootstrap-vue'

export default {
  components: {
    BTab,
    BTabs,
    BCard,
    BAlert,
    BLink,
    BSidebar,
    BForm,
    BFormGroup,
    BFormInput,
    BFormInvalidFeedback,
    BButton,
    BFormSelect,
    BFormSelectOption,
    BFormSpinbutton,

  },

  data(){
    return{
      formData:{
        name:'',
        description:'',
        manager_id:null,
        percentage_advance:'',
        estimated_time:'',
        real_time:'',
        status_id:'',
        project_id:this.$route.params.id,
        activitie_id:this.$route.params.activitie


      },
      activitieData:'',
      status:[{id:1,name:'Nueva'},{id:2,name:'Abierta'},{id:3,name:'Cerrada'},{id:4,name:'Cerrada con retraso'},{id:5,name:'Cancelada'}],
      projectMembers:[],
      min_percentage:0,
      showAlert:false,
      showAlertRequest:false,
      hasWrittenName:false,
      hasWrittenDescription:false,
      errorMessageRequest:'',
      lockedSubmitByName:false,
      lockedSubmitByDescription:false,
      lockedSubmitByRealTime:false,
      lockedSubmitByEstimatedTime:false,
      userId:'',
      statusId:''

    }
  },
  methods:{
    handleSubmit(){

      if(this.formData.name==='' || this.formData.description===''){
          this.showAlert=true
          return
      }else{
      this.$swal({          
          title: '¿Está seguro que desea actualizar la actividad?',
          text: "Los detalles de la actividad pueden ser actualizados después",
          icon: 'warning',
          showCancelButton: true,
          confirmButtonText: 'Si, guardar!',
          customClass: {
            confirmButton: 'btn btn-primary',
            cancelButton: 'btn btn-outline-danger ml-1',
          },
          buttonsStyling: false,

        }).then(result => {
          if (result.value) {

            this.$http.post('project/activities/update',this.formData).then(res =>{
                
              if (res.data.message === "success") {
                this.$swal({
                          icon: 'success',
                          title: 'Guardada!',
                          text: 'La actividad fue actualizada correctamente.',
                          customClass: {
                            confirmButton: 'btn btn-success',
                          },
                })
                this.$router.push({ name: 'apps-project-activities-view', params: { id: this.$route.params.id ,activitie:this.$route.params.activitie } })

              }
              
            }).catch(err=>{
              if (err.response.status == 422){
                console.log('err')
                
                if (err.response.data.errors.rfc){
                  this.showAlertRequest = true
                  this.errorMessageRequest = err.response.data.errors.rfc[0]
                  console.log(err.response.data.errors.rfc[0])
                }
                if (err.response.data.errors.name){
                  this.showAlertRequest = true
                  this.errorMessageRequest = err.response.data.errors.name[0]
                  console.log(err.response.data.errors.name[0])
                }
              }
            })
            
            } else {
            this.$swal({
              title: 'Cancelado',
              text: 'La actividad no ha sido actualizada',
              icon: 'error',
              customClass: {
                confirmButton: 'btn btn-success',
              },
            })
          }
        })
      }
            
    },
    getActivitieData(){
      this.$http.get('project/activities/show',{params:{activitie:this.$route.params.activitie}}).then(res=>{
        this.formData.name = res.data.activitie.name
        if(res.data.activitie.description){
          this.formData.description = res.data.activitie.description
        }
        this.formData.manager_id = res.data.activitie.manager_id
        this.formData.percentage_advance = res.data.activitie.percentage_advance
        this.formData.estimated_time = res.data.activitie.estimated_time
        this.formData.real_time = res.data.activitie.real_time
        this.min_percentage = res.data.activitie.percentage_advance
        this.formData.status_id = res.data.activitie.status_id
        this.activitieData = res.data.activitie
        this.statusId = res.data.activitie.status_id
        this.beforeEnter()

      }).catch(err=>{
        console.log(err)
      })
    },
    getProjectMembers(){
      this.$http.get('project/activities/showProjectMembers',{params:{project:this.$route.params.id}}).then(res=>{
        this.projectMembers = res.data.members
      }).catch(err=>{
        console.log(err)
      })
    },
    beforeEnter(){
        // check vuex store //
        let userData = JSON.parse(localStorage.userData)
        this.userId = userData.id
        if(this.activitieData.project && this.activitieData.status){
          if ((this.activitieData.status.name === 'Abierta' || this.activitieData.status.name === 'Nueva' ) && (this.hasPermission('edit_project_activities') || userData.id === this.activitieData.project.manager_id || userData.id === this.activitieData.manager_id )) {
            return true
          } else if(this.hasPermission('edit_project_activities')){
            return true
          }else {
            this.$router.push({name: "misc-not-authorized"}) 
          }
        }
    }
  },
  computed: {
      validationName() {
        if (this.formData.name.length > 0){
          this.hasWrittenName = true
        } 
        if(this.hasWrittenName){
          if(this.formData.name.length > 0){
            this.lockedSubmitByName = false
            return true
          }else{
            this.lockedSubmitByName = true
            return false
          }
          
        }
      },
      validationDescription(){
        if (this.formData.description.length > 0){
          this.hasWrittenDescription = true
        } 
        if(this.hasWrittenDescription){
          if(this.formData.description.length > 4){
            this.lockedSubmitByDescription = false
            return true
          }else{
            this.lockedSubmitByDescription = true
            return false
          }
          
        }
      },
      validationEstimatedTime() {   
        if(this.formData.status_id > 1){      
          if (this.formData.estimated_time >= 0){
            this.lockedSubmitByEstimatedTime = false
            return true
          }else{
            this.lockedSubmitByEstimatedTime = true
            return false
          }
        }
        
      },
      validationRealTime() { 
        if(this.formData.status_id > 1){   
          if (this.formData.real_time >= 0){
            this.lockedSubmitByRealTime = false
            return true
          }else{
            this.lockedSubmitByRealTime = true
            return false
          }
        }
          
      },
      checkStatus(){
        if(this.formData.status_id  === 1){
          this.formData.estimated_time = 0
          this.formData.real_time = 0
          this.formData.percentage_advance = 0
          return false

        }else{
          if(this.formData.status_id  === 3 || this.formData.status_id  === 4){

            this.formData.percentage_advance = 100

          }else{
            this.$http.get('project/activities/show',{params:{activitie:this.$route.params.activitie}}).then(res=>{

              this.formData.percentage_advance = res.data.activitie.percentage_advance
              this.formData.estimated_time = res.data.activitie.estimated_time
              this.formData.real_time = res.data.activitie.real_time
              this.min_percentage = res.data.activitie.percentage_advance

            }).catch(err=>{
              console.log(err)
            })
            return true
          }
        }
      }
      
      
     
    },
    mounted(){
      this.getProjectMembers()
      this.getActivitieData()
      
      
      
    }



}
</script>

<style>

</style>
